unit SPIENC;
interface
uses windows, sysutils, DateUtils, ENCConst, zlportio;

var
ENC_INT :boolean = False;
ENC_WOL :boolean = False;

procedure LPTBasis(Data:word);
procedure ENCOut(Data:byte);
function ENCIn():byte;
procedure ENCPoll();
procedure ENCComp();
procedure ENC_WCR(creg:word;Data:byte);
function ENC_RCR(creg:word):byte;
procedure ENC_BFS(creg:word;Data:byte);
procedure ENC_BFC(creg:word;Data:byte);
procedure ENC_OpenRBM();
procedure ENC_OpenWBM();
procedure ENC_PHY_Write(reg:byte;Data:word);
function ENC_PHY_Read(reg:byte):word;
procedure ENC_SC();
procedure ENCStart();

implementation
type

  Tbank = record
    fc  : boolean;
    cm, cd: byte;
  end;
  TAbank = array[0..3,0..3] of Tbank;

const
ENC_Reset = $F5;  {1111 0101}
ENC_Stb   = $FC;  {1111 1101}
ENC_SCK_L = $F8;  {1111 1000}
ENC_SCK_H = $FA;  {1111 1010}

sbank: TAbank = (((fc: false; cm: 0; cd :0)  ,(fc: false; cm: 160; cd :3),
                  (fc: false; cm: 160; cd :3),(fc: false; cm: 160; cd :3)),
                 ((fc: false; cm: 128; cd :1),(fc: false; cm: 0; cd :0),
                  (fc: true;  cm: 128; cd :1),(fc: false; cm: 160; cd :2)),
                 ((fc: false; cm: 128; cd :2),(fc: true;  cm: 128; cd :2),
                  (fc: false; cm: 0; cd :0)  ,(fc: false; cm: 160; cd :1)),
                 ((fc: false; cm: 128; cd :3),(fc: false; cm: 128; cd :3),
                  (fc: false; cm: 128; cd :3),(fc: false; cm: 0; cd :0)));

var
ENC_cregbank:Byte = 255;
LPTPort     :Word = $378;
LPTCont     :Word = $379;

procedure LPTBasis(Data:word);
begin
 LPTPort:=Data;
 LPTCont:=Data+1;
end;

procedure ENCOut(Data:byte);
var
 OBit, dbs :Byte;
begin
 dbs:=Data;
 if dbs div 128 = 1 then begin dbs:=dbs mod 128; OBit:=1; end else OBit:=0;
 portwriteb( LPTPort, ENC_SCK_L+OBit );
 portwriteb( LPTPort, ENC_SCK_H+OBit );
 if dbs div 64 = 1 then begin dbs:=dbs mod 64; OBit:=1; end else OBit:=0;
 portwriteb( LPTPort, ENC_SCK_L+OBit );
 portwriteb( LPTPort, ENC_SCK_H+OBit );
 if dbs div 32 = 1 then begin dbs:=dbs mod 32; OBit:=1; end else OBit:=0;
 portwriteb( LPTPort, ENC_SCK_L+OBit );
 portwriteb( LPTPort, ENC_SCK_H+OBit );
 if dbs div 16 = 1 then begin dbs:=dbs mod 16; OBit:=1; end else OBit:=0;
 portwriteb( LPTPort, ENC_SCK_L+OBit );
 portwriteb( LPTPort, ENC_SCK_H+OBit );
 if dbs div 8 = 1 then begin dbs:=dbs mod 8; OBit:=1; end else OBit:=0;
 portwriteb( LPTPort, ENC_SCK_L+OBit );
 portwriteb( LPTPort, ENC_SCK_H+OBit );
 if dbs div 4 = 1 then begin dbs:=dbs mod 4; OBit:=1; end else OBit:=0;
 portwriteb( LPTPort, ENC_SCK_L+OBit );
 portwriteb( LPTPort, ENC_SCK_H+OBit );
 if dbs div 2 = 1 then begin dbs:=dbs mod 2; OBit:=1; end else OBit:=0;
 portwriteb( LPTPort, ENC_SCK_L+OBit );
 portwriteb( LPTPort, ENC_SCK_H+OBit );
 portwriteb( LPTPort, ENC_SCK_L+dbs );
 portwriteb( LPTPort, ENC_SCK_H+dbs );
end;

function ENCIn():byte;
begin
 result :=0;
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_SCK_H );
 if portreadb( LPTCont )<128 Then result:=result+128;
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_SCK_H );
 if portreadb( LPTCont )<128 Then result:=result+64;
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_SCK_H );
 if portreadb( LPTCont )<128 Then result:=result+32;
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_SCK_H );
 if portreadb( LPTCont )<128 Then result:=result+16;
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_SCK_H );
 if portreadb( LPTCont )<128 Then result:=result+8;
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_SCK_H );
 if portreadb( LPTCont )<128 Then result:=result+4;
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_SCK_H );
 if portreadb( LPTCont )<128 Then result:=result+2;
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_SCK_H );
 if portreadb( LPTCont )<128 Then result:=result+1;
end;

procedure ENCPoll();
var
CPort :Byte;
begin
 CPort:=portreadb( LPTCont );
 if (CPort and 32)=32 then ENC_INT:=false else ENC_INT:=true;
 if (CPort and 16)=16 then ENC_WOL:=false else ENC_WOL:=true;
end;

procedure ENCComp();
begin
 portwriteb( LPTPort, ENC_SCK_L );
 portwriteb( LPTPort, ENC_Stb );
end;

procedure ENC_WCR(creg:word;Data:byte);
var
bank,reg :Byte;
begin
 reg:=creg mod 256; bank:=(creg div 256)and 127;
 if (bank <> ENC_cregbank) and (reg < $1B) then begin
    if sbank[bank,ENC_cregbank].fc then begin
       ENCOut((N_ECON1 mod 256)+160);ENCOut(3);
       ENCComp; end;
    ENCOut((N_ECON1 mod 256)+sbank[bank,ENC_cregbank].cm);
    ENCOut(sbank[bank,ENC_cregbank].cd); ENCComp;
    ENC_cregbank:=bank; end;
 ENCOut(reg+64);ENCOut(Data);ENCComp;
end;

function ENC_RCR(creg:word):byte;
var
bank,reg :Byte;
mac :boolean;
begin
 reg:=creg mod 256; bank:=creg div 256;
 if bank > 127 then begin bank:=bank and 127; mac:=true end else mac:=false;
 if (bank <> ENC_cregbank) and (reg < $1B) then begin
    if sbank[bank,ENC_cregbank].fc then begin
       ENCOut((N_ECON1 mod 256)+160);ENCOut(3);
       ENCComp; end;
    ENCOut((N_ECON1 mod 256)+sbank[bank,ENC_cregbank].cm);
    ENCOut(sbank[bank,ENC_cregbank].cd); ENCComp;
    ENC_cregbank:=bank; end;
 ENCOut(reg);
 If mac then ENCin;
 result:= ENCin; ENCComp;
end;

procedure ENC_BFS(creg:word;Data:byte);
var
bank,reg :Byte;
begin
 reg:=creg mod 256; bank:=(creg div 256)and 127;
 if (bank <> ENC_cregbank) and (reg < $1B) then begin
    if sbank[bank,ENC_cregbank].fc then begin
       ENCOut((N_ECON1 mod 256)+160);ENCOut(3);
       ENCComp; end;
    ENCOut((N_ECON1 mod 256)+sbank[bank,ENC_cregbank].cm);
    ENCOut(sbank[bank,ENC_cregbank].cd); ENCComp;
    ENC_cregbank:=bank; end;
 ENCOut(reg+128);ENCOut(Data);ENCComp;
end;

procedure ENC_BFC(creg:word;Data:byte);
var
bank,reg :Byte;
begin
 reg:=creg mod 256; bank:=(creg div 256)and 127;
 if (bank <> ENC_cregbank) and (reg < $1B) then begin
    if sbank[bank,ENC_cregbank].fc then begin
       ENCOut((N_ECON1 mod 256)+160);ENCOut(3);
       ENCComp; end;
    ENCOut((N_ECON1 mod 256)+sbank[bank,ENC_cregbank].cm);
    ENCOut(sbank[bank,ENC_cregbank].cd); ENCComp;
    ENC_cregbank:=bank; end;
 ENCOut(reg+160);ENCOut(Data);ENCComp;
end;

procedure ENC_OpenRBM();
begin
 ENCOut(58);
end;

procedure ENC_OpenWBM();
begin
 ENCOut(122);
end;

procedure ENC_PHY_Write(reg:byte;Data:word);
begin
  Repeat Until (N_BUSY and ENC_RCR(N_MISTAT))<>N_BUSY;
  ENC_WCR(N_MIREGADR,reg);
  ENC_WCR(N_MIRDL,Data mod 256);
  ENC_WCR(N_MIRDH,Data div 256);
end;

function ENC_PHY_Read(reg:byte):word;
begin
  Repeat Until (N_BUSY and ENC_RCR(N_MISTAT))<>N_BUSY;
  ENC_WCR(N_MIREGADR,reg);
  ENC_BFS(N_MICMD,N_MIIRD);
  Repeat Until (N_BUSY and ENC_RCR(N_MISTAT))<>N_BUSY;
  ENC_BFC(N_MICMD,N_MIIRD);
  result:=ENC_RCR(N_MIRDL)+ENC_RCR(N_MIRDH) shl 8
end;

procedure ENC_SC();
begin
 ENCOut(255);ENCComp;
 ENC_cregbank:=0;
 Repeat Until (N_CLKRDY and ENC_RCR(N_ESTAT))=N_CLKRDY;
end;

procedure ENCStart();
begin
 portwriteb( LPTPort, ENC_Reset );
 portwriteb( LPTPort, ENC_Stb );
 ENC_cregbank:=0;
 Repeat Until (N_CLKRDY and ENC_RCR(N_ESTAT))=N_CLKRDY;
end;
end.
